> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://developer.projectmanager.com/api-reference/project-members/create-user-project-membership/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.projectmanager.com/_mcp/server. # Create User Project Membership POST https://api.projectmanager.com/api/data/projects/{projectId}/members/{userId} Content-Type: application/json Creates a membership for a user in a specified project and assigns the user the appropriate project access based on the specified project security role. A project member is a user who has access to a specific project. Project members are assigned a project security role, which controls the level of access they have to the project. Possible project security roles include manage, edit, collaborate, creator, and guest. Reference: https://developer.projectmanager.com/api-reference/project-members/create-user-project-membership ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Path parameters - `projectId` (string, required) — Reference to Project - `userId` (string, required) — Reference to User ### Headers - `x-integration-name` (string, optional) — The name of the calling system passed along as a header parameter ### Body (application/json) This endpoint expects a ProjectMemberRoleDto. - `role` (enum, optional, nullable) — Role to apply. Optional — when omitted, a default role is applied based on the target user's workspace access: users who can edit all projects become a Manager, guest users become a Guest, and everyone else becomes an Editor. When updating an existing member, omitting the role leaves their current role unchanged. - Allowed values: `Guest`, `Collaborate`, `Editor`, `Manager` ## Response ### 200 Success - `error` (AstroError, optional, nullable) — If the API call failed, this will contain information about the error that occurred. - `success` (boolean, optional) — True if the API call succeeded; false otherwise. - `hasError` (boolean, optional) — True if the API call failed. - `statusCode` (enum, optional) — The HTTP code of the response. - Allowed values: `Continue`, `SwitchingProtocols`, `Processing`, `EarlyHints`, `OK`, `Created`, `Accepted`, `NonAuthoritativeInformation`, `NoContent`, `ResetContent`, `PartialContent`, `MultiStatus`, `AlreadyReported`, `IMUsed`, `MultipleChoices`, `MovedPermanently`, `Found`, `SeeOther`, `NotModified`, `UseProxy`, `Unused`, `TemporaryRedirect`, `PermanentRedirect`, `BadRequest`, `Unauthorized`, `PaymentRequired`, `Forbidden`, `NotFound`, `MethodNotAllowed`, `NotAcceptable`, `ProxyAuthenticationRequired`, `RequestTimeout`, `Conflict`, `Gone`, `LengthRequired`, `PreconditionFailed`, `RequestEntityTooLarge`, `RequestUriTooLong`, `UnsupportedMediaType`, `RequestedRangeNotSatisfiable`, `ExpectationFailed`, `MisdirectedRequest`, `UnprocessableEntity`, `Locked`, `FailedDependency`, `UpgradeRequired`, `PreconditionRequired`, `TooManyRequests`, `RequestHeaderFieldsTooLarge`, `UnavailableForLegalReasons`, `InternalServerError`, `NotImplemented`, `BadGateway`, `ServiceUnavailable`, `GatewayTimeout`, `HttpVersionNotSupported`, `VariantAlsoNegotiates`, `InsufficientStorage`, `LoopDetected`, `NotExtended`, `NetworkAuthenticationRequired` - `data` (ProjectMemberDto, optional) — A ProjectMember is a user who can collaborate on a Project. You can control permissions for what each ProjectMember can do and how they can interact with the Project using this model. ## Types ### AstroError Information about an error that occurred within the ProjectManager API. - `technicalError` (string, optional, nullable) — A technical description of the error that occurred. Not suitable for display to end users. - `additionalErrors` (list of string, optional, nullable) — If additional errors beyond the main error in `Message` occurred, they will be listed here as individual messages. - `validationErrors` (map from string to list of string, optional, nullable) — This contains a dictionary of validation errors. The key is the name of the field - `message` (string, optional, nullable) — A description of the error that occurred. If your application has a user interface, show this message to explain what went wrong. ### ProjectMemberDto A ProjectMember is a user who can collaborate on a Project. You can control permissions for what each ProjectMember can do and how they can interact with the Project using this model. - `id` (string, optional) — The unique identifier of the user of this ProjectMember. - `projectId` (string, optional) — The unique identifier of the project that this ProjectMember belongs to. - `initials` (string, optional) — the initials of the user - `name` (string, optional) — The display name of the user - `avatarUrl` (string, optional, nullable) — Avatar URL - `permission` (string, optional, nullable) — The current permission of the user - `color` (string, optional) — The color for their avatar - `permissionOptions` (PermissionOptionsDto, optional, nullable) — Specifies the permissions that you can set against the project member. This changes based on who is logged in and the role they have. - `role` (string, optional, nullable, deprecated) — The role of the user in the project Obsolete use Permission instead ### PermissionOptionsDto Specifies the permissions a member can be changed to on a project. This objects values can change based on the logged in user and the role they have. - `none` (boolean, optional) — If true, the users access can be removed - `collaborate` (boolean, optional) — If true the user can be changed to collaborator - `guest` (boolean, optional) — If true a user can be set as guest, a guest can only be Guest or None - `editor` (boolean, optional) — If true the user can be changed to editor - `manager` (boolean, optional) — If true the user can be changed to Manager ## Examples **Request** ```json {} ``` **Response** ```json { "error": { "technicalError": "string", "additionalErrors": [ "string" ], "validationErrors": {}, "message": "string" }, "success": true, "hasError": true, "statusCode": "Continue", "data": { "id": "string", "projectId": "string", "initials": "string", "name": "string", "avatarUrl": "string", "permission": "string", "color": "string", "permissionOptions": { "none": true, "collaborate": true, "guest": true, "editor": true, "manager": true }, "role": "string" } } ``` **SDK Code** ```python import requests url = "https://api.projectmanager.com/api/data/projects/projectId/members/userId" payload = {} headers = { "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.projectmanager.com/api/data/projects/projectId/members/userId'; const options = { method: 'POST', headers: {Authorization: 'Bearer ', 'Content-Type': 'application/json'}, body: '{}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.projectmanager.com/api/data/projects/projectId/members/userId" payload := strings.NewReader("{}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.projectmanager.com/api/data/projects/projectId/members/userId") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.projectmanager.com/api/data/projects/projectId/members/userId") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{}") .asString(); ``` ```php request('POST', 'https://api.projectmanager.com/api/data/projects/projectId/members/userId', [ 'body' => '{}', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.projectmanager.com/api/data/projects/projectId/members/userId"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = [] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.projectmanager.com/api/data/projects/projectId/members/userId")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```